#include <avr/io.h>
#include <stdio.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <stdlib.h>
#include <inttypes.h>
#include <avr/eeprom.h>
#include <string.h>
#include <avr/twi.h>
#include "Serial.h"
#include "Delay.h"
#include "TWI.h"

#define COMPASS_ADDRESS 0xC0

//#define SYSCLK 14745600UL
//#define SYSCLK   3686400UL
#define SYSCLK   8000000UL

char GetCompassData(unsigned char *Data)
{
   char Result;

   Result = TWI_GetData(COMPASS_ADDRESS, 0, Data, 16);
   if (Result) return Result;

   return 0;
}

void Init()
{
   outb(DDRB, 0);
   outb(DDRC, 0);
   outb(DDRD, 0);

   delay(0x0100);

   UART_Init(23);
   TWI_Init(SYSCLK);
   sei();
}

int main(void)
{
   unsigned char RawData[17];
   char Output[32];
   char error1;

   Init();
   UART_clr();
   UART_TransmitLine("Compiled ");
   UART_TransmitLine(__DATE__);
   UART_TransmitLine(__TIME__);
   UART_TransmitLine("\n\r");

   while (1)
   {
UART_TransmitLine("---\n\r");
      error1 = GetCompassData(RawData);
      if (error1 == 0)
      {
         itoa((RawData[2] << 8) + RawData[3], Output, 10);
         UART_TransmitLine(Output);
         UART_TransmitLine(" - ");
         itoa(RawData[1], Output, 10);
         UART_TransmitLine(Output);
         UART_TransmitLine("\n\r");
      }
      else
      {
         itoa(error1, Output, 10);
         UART_TransmitLine("Error1: ");
         UART_TransmitLine(Output);
         UART_TransmitLine("\n\r");
      }
      delay(0x0100);
   }
}

