#ifndef __POD_INCLUDES_H__
#define __POD_INCLUDES_H__

#include <string.h>
#include <avr/eeprom.h>
#include "Serial.h"

void Process_Command_Ping()
{
   UART_TransmitByte(POD_RESPONSE_PONG);
}

void Process_Command_GetType()
{
   UART_TransmitByte(POD_RESPONSE_ACK);
   UART_TransmitWord(PodType);
}

void Process_Command_SetName()
{
   char Counter;
   unsigned char Buffer;

   for (Counter = 0 ; Counter < POD_EEPROM_NAME_LEN ; Counter ++)
   {
      Buffer = UART_ReceiveByte();
      eeprom_write_byte((uint8_t *)(POD_EEPROM_NAME_ADDR + Counter), Buffer);
   }
   UART_TransmitByte(POD_RESPONSE_ACK);
}

void Process_Command_GetName()
{
   char Counter;
   unsigned char Buffer;

   UART_TransmitByte(POD_RESPONSE_ACK);
   for (Counter = 0 ; Counter < POD_EEPROM_NAME_LEN ; Counter ++)
   {
      Buffer = eeprom_read_byte((uint8_t *)(POD_EEPROM_NAME_ADDR + Counter));
      if (Buffer == 0xFF) Buffer = '\0';
      UART_TransmitByte(Buffer);
   }
}

void Process_Command_GetInfo()
{
   UART_TransmitByte(POD_RESPONSE_ACK);
   UART_TransmitWord(PodType);
   /* send version info - 21 bytes of "Jun  2 2003, 13:51:38" + 3 bytes \0 pad */
   UART_TransmitLine(__DATE__);
   UART_TransmitLine(", ");
   UART_TransmitLine(__TIME__);
   UART_TransmitByte(0x00);
   UART_TransmitByte(0x00);
   UART_TransmitByte(0x00);
   UART_TransmitByte(strlen(POD_VAR_URL) + 1);
   UART_TransmitLine(POD_VAR_URL);
   UART_TransmitByte(0x00);
}

void Send_NACK()
{
   UART_TransmitByte(POD_RESPONSE_NACK);
}

int eeprom_write_word(uint16_t *Address, uint16_t Data)
{
   eeprom_write_byte((uint8_t *)(Address), (Data >> 8) & 0xFF);
   eeprom_write_byte((uint8_t *)(Address + 1), Data & 0xFF);
   return(0);
}

#endif /* ifndef __POD_INCLUDES_H__ */
